'use strict';

angular.module('adf.widget.electre.lavoisier')
    .value('renderingTextList',{
        defaultRendering : 'txt',
        renderings : [
            'txt',
            'csv',
            'json',
            'json2',
            'jsonml',
            'ldif',
            'sql',
            'xml'

            //DEVELOPPEUR
    //        'rowcol'
        ]
    })
    .controller('lavoisierTextEditCtrl',
        [
            '$scope', 'config', '$controller', 'domService', 'renderingFactory', 'renderingTextList',
            function ($scope, config, $controller, domService, renderingFactory, renderingTextList) {
                $controller('lavoisierBaseEditCtrl',
                    {
                        $scope : $scope,
                        config : config
                    }
                );
                config.fontSize = config.fontSize || "14";

                renderingFactory.createRenderingDomFromArray(renderingTextList, angular.element(document.getElementById('edit_form_div_lavoisier')), config);

                var div = domService.createElement("div").setAttribute('class', "form-group").getDom();
                var label = domService.createElement("label").setAttribute('for', "text-edit-font-size").getDom();
                label.innerHTML = "Font Size";
                var select = domService.createElement("select")
                    .setAttribute('id', "text-edit-font-size")
                    .setAttribute('class', "form-control")
                    .setAttribute('ng-model', "config.fontSize")
                    .getDom();
                for (var o = 1 ; o <= 8 ; o++) {
                var font_size_value = (6 + (o * 2));
                    var option = domService.createElement("option").setAttribute('value', font_size_value).getDom();
                    option.innerHTML = font_size_value;
                    select.appendChild(option);
                }

                div.appendChild(label); div.appendChild(select);
                console.log(div);
                console.log(document.getElementById('edit_form_div_lavoisier'));
                angular.element(document.getElementById('edit_form_div_lavoisier')).append(div);
            }
        ]
    ).controller('lavoisierTextCtrl',
         [
             '$scope', 'config', "baseController",
             function ($scope, config, baseController) {
                 if (config.baseurl) {
                     $scope.text = {
                         controller : {
                             success : function () {
                                 $scope.success = true;
                             },
                             failed : function () {
                                 $scope.success = false;
                             },
                             setValue : function (value) {
                                 $scope.value = value;
                             }
                         },
                         config  : baseController.getUrlObject(config),
                         fontSize : config.fontSize
                     };

                     $scope.valid = true;
                 }
             }
         ]
    ).directive('textDisplay',
         [
             'lavoisierHttpRequestService', 'domService',
             function (lavoisierHttpRequestService, domService) {
                 function htmlEntities(str) {
                     return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
                 }

                 return {
                     scope : {
                         control : '='
                     },
                     link : function (scope, element, attrs) {
                         if (element.children().length > 0) element.empty();
                             console.log(scope.control.config);
                         lavoisierHttpRequestService.getResult_2(scope.control.config)
                         .then(
                             function (value) {
                                 console.log(value);
                                 scope.value = htmlEntities(value);
                                 scope.control.controller.setValue(value);

                                 var textarea = domService.createElement("textarea")
                                         .setAttribute('style', "width:100%;min-height:296px;margin-top:15px;font-size:" + scope.control.fontSize + "px;")
                                         .setAttribute('disabled', 'disabled').getDom();

                                 textarea.innerHTML = scope.value;

                                 element.prepend(textarea);
                             },
                             function () {
                                 var txt = "An error has occurred during the request. Please verify you have entered valid info.";
                                 var p = domService.createElement("p").setAttribute('class', "alert alert-warning").getDom();
                                 p.innerHTML = txt;
                                 element.append(p);

                                 throw txt;
                             }
                         ).then(
                             function () {
                                 scope.control.controller.success();
                             }, function () {
                                 scope.control.controller.failed();
                             }
                         );
                     }
                 };
             }
         ]
    ).directive('copyToClipboard',
         [
             function () {
                return {
                    link : function (scope, element, attrs) {
                        new Clipboard(element[0], {
                            target : function () {
                                return element[0].previousElementSibling;
                            }
                        });
                    }
                };
             }
         ]
    );